
/* 
** Ember will look for the module either in INST_DIR/modules or using
** the value we specify as the absolute path.  So, we can just reference
** the shared object in the source directory
*/
modload "../src/mod_msql";


/*
** Define a couple of convenience routines
*/

funct doQuery(int $sock, text $query)
{
	if (msqlQuery($sock, $query) < 0)
	{
		echo("mSQL Error : $ERRMSG\nQ=$query\n\n");
		exit(1);
	}
}


funct doSelectQuery(int $sock, text $query)
{
	if (msqlQuery($sock, $query) < 0)
	{
		echo("mSQL Error : $ERRMSG\nQ=$query\n\n");
		exit(1);
	}
	$res = msqlStoreResult();
	return($res);
}


/*
** On with the show, connect to the database we want
*/

$sock = msqlConnect();
if ($sock < 0)
{
	echo("Error : $ERRMSG\n");
	exit(1);
}

if (msqlSelectDB($sock,"test") < 0)
{
	echo("Can't select 'test' database : $ERRMSG\n");
	exit(1);
}

/*
** Ensure the table we want exists
*/
$tables = msqlListTables($sock);
$count = 0;
while($count < # $tables)
{
	$table = $tables[$count];
	if ($table == "test_1")
	{
		echo("Dropping table 'test_1'\n");
		doQuery($sock,"drop table test_1");
	}
	$count++;
}

echo("Creating table 'test_1'\n");
doQuery($sock,"create table test_1 (first CHAR(20), last CHAR(20), age INT)");
doQuery($sock,"insert into test_1 values ('Bill','Smith',21)");
doQuery($sock,"insert into test_1 values ('James','Brown',60)");
doQuery($sock,"insert into test_1 values ('Fred','Flintstone',99)");
doQuery($sock,"insert into test_1 values ('John','Howard',52)");

/*
** Query the table
*/
echo("\n");
$res = doSelectQuery($sock, "select first,last,age from test_1 order by last");
$row = msqlFetchRow($res);
while(# $row > 0)
{
	$first = $row[0];
	$last = $row[1];
	$age = $row[2];
	echo("$last,$first is $age\n");
	$row = msqlFetchRow($res);
}
msqlFreeResult($res);
msqlClose($sock);
